tests: vsock: Use VMADDR_CID_LOCAL for loopback testing.
[nbdkit/ericb.git] / tests / test-captive.sh
blob8762b86146dd6a8af3d00095ab9510b0a062d7ca
1 #!/usr/bin/env bash
2 # nbdkit
3 # Copyright (C) 2014-2019 Red Hat Inc.
5 # Redistribution and use in source and binary forms, with or without
6 # modification, are permitted provided that the following conditions are
7 # met:
9 # * Redistributions of source code must retain the above copyright
10 # notice, this list of conditions and the following disclaimer.
12 # * Redistributions in binary form must reproduce the above copyright
13 # notice, this list of conditions and the following disclaimer in the
14 # documentation and/or other materials provided with the distribution.
16 # * Neither the name of Red Hat nor the names of its contributors may be
17 # used to endorse or promote products derived from this software without
18 # specific prior written permission.
20 # THIS SOFTWARE IS PROVIDED BY RED HAT AND CONTRIBUTORS ''AS IS'' AND
21 # ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
22 # THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
23 # PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL RED HAT OR
24 # CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
25 # SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
26 # LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
27 # USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
28 # ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
29 # OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
30 # OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
31 # SUCH DAMAGE.
33 source ./functions.sh
34 set -e
35 set -x
37 # Test nbdkit --run (captive nbdkit) option.
39 fail=0
41 sock=`mktemp -u`
42 files="$sock captive.out captive.pid"
43 rm -f $files
44 cleanup_fn rm -f $files
46 nbdkit -U $sock example1 --run '
47 echo nbd=$nbd; echo port=$port; echo socket=$unixsocket
48 ' > captive.out
50 # Check the output.
51 if [ "$(cat captive.out)" != "nbd=nbd:unix:$sock
52 port=
53 socket=$sock" ]; then
54 echo "$0: unexpected output"
55 cat captive.out
56 fail=1
59 # Check that a failed --run process affects exit status
60 status=0
61 nbdkit -U - example1 --run 'exit 2' > captive.out || status=$?
62 if test $status != 2; then
63 echo "$0: unexpected exit status $status"
64 fail=1
66 if test -s captive.out; then
67 echo "$0: unexpected output"
68 cat captive.out
69 fail=1
72 # Check that nbdkit death from unhandled signal affects exit status
73 status=0
74 nbdkit -U - -P captive.pid example1 --run '
75 for i in {1..60}; do
76 if test -s captive.pid; then break; fi
77 sleep 1
78 done
79 if ! test -s captive.pid; then
80 echo "$0: no pidfile yet"
81 exit 10
83 kill -s ABRT $(cat captive.pid) || exit 10
84 sleep 10
85 ' > captive.out || status=$?
86 if test $status != $(( 128 + $(kill -l ABRT) )); then
87 echo "$0: unexpected exit status $status"
88 fail=1
90 if test -s captive.out; then
91 echo "$0: unexpected output"
92 cat captive.out
93 fail=1
96 exit $fail